routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('admin');
Route::get('/reset-password', function () {
    return View::make('reset-password');
});

Auth::routes();

Route::group(['prefix' => 'admin', 'middleware' => ['auth']],function(){
	Route::get('/dashboard', 'DashboardController@index')->name('dashboard');
	Route::get('users/blocked/{id}', 'UserController@block');
	Route::get('export', 'UserController@export')->name('export');
	Route::resource('users', 'UserController');
	Route::get('workoutPlans/deactivate/{id}', 'WorkoutPlanController@deactivate');
	Route::get('workoutPlans/getSubcategory', 'WorkoutPlanController@getSubcategory')->name('getSubcategory');
	Route::resource('workoutPlans', 'WorkoutPlanController');
	Route::resource('cms', 'CmsPageController');
	Route::get('edit-profile', 'ProfileController@editProfile')->name('edit.profile');
	Route::put('update-profile', 'ProfileController@updateProfile')->name('update.profile');
	Route::get('change-password', 'ProfileController@changePassword')->name('change.password');
	Route::put('update-password', 'ProfileController@updatePassword')->name('update.password');
	Route::resource('subscriptions', 'SubscriptionController');
	Route::resource('forums', 'CommunityBoardController');
	Route::post('forum-comment-delete/{id}', 'CommunityBoardController@deleteComment')->name('delete-comment');
	Route::resource('contactUs', 'InquiryController');
	Route::resource('categories', 'CategoryController');
	Route::resource('subcategories', 'SubcategoryController');
	Route::resource('ageGroups', 'AgeGroupController');
	Route::resource('routines', 'RoutineController');
	Route::resource('reported-forums', 'ReportedForumController');
});

Route::get('cms/{slug}', 'CmsPageController@view_cms');

app/WorkoutPlan.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Auth;

class WorkoutPlan extends Model
{
    protected $fillable = [
        'name','media','short_description','category_id','duration','calories_burn','thumbnail','is_activated','subcategory_id','routine_id','age_group_id'
    ];

    public function category(){
        return $this->belongsTo('App\Category', 'category_id', 'id');
    }
    
    public function workoutSchedule(){
        return $this->hasMany('App\WorkoutTiming', 'workout_plan_id', 'id')->where('user_id', Auth::id());
    }
}

app/Http/Controllers/API/v1/WorkoutPlanController.php
<?php

namespace App\Http\Controllers\API\v1;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Carbon\Carbon;
use App\WorkoutPlan;
use App\Category;
use App\Subcategory;
use App\WorkoutTiming;
use App\Routine;
use App\AgeGroup;
use Auth;
use Validator;

class WorkoutPlanController extends Controller
{
    public $successStatus = 200;
    public $errorStatus = 400;
    
    public function workoutPlanList(Request $request)
    {
        if(!empty($request->input('category_id'))&& ($request->input('category_id') != "null")){
            $category_id = $request->input('category_id');
            $workoutPlans = WorkoutPlan::where('category_id',$category_id)->where('is_activated', 1)->with('workoutSchedule')->get();
        }else if(!empty($request->input('search'))&& ($request->input('search') != "null")){
            $search = $request->input('search');
            $workoutPlans = WorkoutPlan::where('name','LIKE','%'.$search.'%')->orWhere('short_description','LIKE','%'.$search.'%')->where('is_activated', 1)->with('workoutSchedule')->get();
        }else{
            $workoutPlans = WorkoutPlan::where('is_activated', 1)->with('workoutSchedule')->get();
        }
        
        /*foreach($workoutPlans as $key => $plan){
            $workoutPlans[$key]->media = asset('/workoutMedia/'.$plan->media);
            $workoutPlans[$key]->thumbnail = asset('/workoutMedia/thumbnails/'.$plan->thumbnail);
            $workoutPlans[$key]->category_id = $workoutPlans[$key]->category_id != null ? $workoutPlans[$key]->category->name : null;
        }*/
        
        if (count($workoutPlans) > 0)
            return response()->json(['status_code' => $this->successStatus , 'message' => '', 'data' => $workoutPlans]);
        else
            return response()->json(['status_code' => $this->errorStatus , 'message' => 'There are no workout plans.', 'data' => null]);
    }
    
    public function categoriesList(Request $request)
    {
        $success['categories'] = Category::select('id','name')->orderBy('name', 'ASC')->get()->toArray();
        $user = Auth::user();
        $success['selectedCategory'] = $user->health_goal;
        
        if (count($success['categories']) > 0)
            return response()->json(['status_code' => $this->successStatus , 'message' => '', 'data' => $success]);
        else
            return response()->json(['status_code' => $this->errorStatus , 'message' => 'There are no categories available.', 'data' => null]);
        
    }
    
    public function addWorkoutTimings(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'workout_plan_id' => 'required',
            'date' => 'required',
            'time' => 'required',
        ]);        

        if ($validator->fails())
            return response()->json(['status_code'=> $this->errorStatus, 'message'=> $validator->errors()->first()]);
            
        $time = Carbon::parse($request->date.''.$request->time, Auth::user()->time_zone)->setTimezone('UTC'); 
        $date = Carbon::parse($request->date)->setTimezone('UTC')->format('Y-m-d'); 
        $currentTime = Carbon::now()->setTimezone('UTC');
         
        $schedule =  WorkoutTiming::where('user_id', Auth::id())->where('date', $date)->where('time', $time->format('H:i:s'))->get(); 
        
        if ($schedule->count() > 0)
            return response()->json(['status_code'=> $this->errorStatus, 'message'=> 'Workout is already scheduled.']);

        $diff = $time->diffInMinutes($currentTime); 
        
        if ($diff < 30)
            return response()->json(['status_code'=> $this->errorStatus, 'message'=> 'Please schedule the workout more than 30 mins from the current time.']);
            
        if ($time->lt($currentTime))
            return response()->json(['status_code'=> $this->errorStatus, 'message'=> 'Sorry!! you cannot schedule the workout in the past time.']);
          
        $input = $request->input();
        $input['user_id'] = Auth::id();
        $input['date'] = $date;
        $input['time'] = $time->format('H:i:s'); //dd($input);
        $workoutTiming = WorkoutTiming::create($input);
        
        return response()->json(['status_code'=> $this->successStatus, 'message'=> 'Thank you!! your workout schedule has been added successfully.', 'data' => '']);
        
    }
    
    public function updateWorkoutTimings(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'id' => 'required',
            'date' => 'required',
            'time' => 'required',
        ]);        

        if ($validator->fails())
            return response()->json(['status_code'=> $this->errorStatus, 'message'=> $validator->errors()->first()]);
        
        $input = $request->input();
        $workoutTiming = WorkoutTiming::findOrFail($input['id']);
        
        if($workoutTiming){
            $workoutTiming->fill($input);
            $workoutTiming->save();
            return response()->json(['status_code' => $this->successStatus, 'message' => 'Thank you!! your workout schedule has been updated successfully.','data' => '']);
        }else{
            return response()->json(['status_code' => $this->errorStatus, 'message' => 'Your workout schedule can not updated successfully.','data' => '']);
        }
        
    }
    
    public function dashboard(Request $request)
    {
        $success['routines'] = Routine::get();
        $success['ageGroups'] = AgeGroup::get();
        $success['categories'] = Category::get();
        
        return response()->json(['status_code' => $this->successStatus , 'message' => '', 'data' => $success]);
    }
    
    public function workoutsByCategory(Request $request)
    {
        $input = $request->input();
        $success['ageGroups'] = AgeGroup::get();
        $success['subcategories'] = Subcategory::where('category_id',$input['category_id'])->get();
        
        if (!empty($request->input('subcategory_id'))&& ($request->input('subcategory_id') != "null") && !empty($request->input('age_group_id'))&& ($request->input('age_group_id') != "null")){
            $cat = $request->input('category_id');
            $subcat = $request->input('subcategory_id');
            $age = $request->input('age_group_id');
            
            $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)
            ->where('category_id',$input['category_id'])
            ->whereRaw('FIND_IN_SET(?,REPLACE(subcategory_id,",",","))')
            ->whereRaw('FIND_IN_SET(?,REPLACE(age_group_id,",",","))')
            ->with('workoutSchedule')
            ->setBindings([1, $cat, $subcat, $age])
            ->get();
        
        } else if (!empty($request->input('age_group_id'))&& ($request->input('age_group_id') != "null")){
            $cat = $request->input('category_id');
            $age = $request->input('age_group_id');
            \DB::enableQueryLog();
            $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)
            ->where('category_id',$input['category_id'])
            ->whereRaw('FIND_IN_SET(?,REPLACE(age_group_id,",",","))')
            ->with('workoutSchedule')
            ->setBindings([1, $cat, $age])
            ->get();
            //dd(\DB::getQueryLog());
           
        } else if (!empty($request->input('subcategory_id'))&& ($request->input('subcategory_id') != "null")){
            $cat = $request->input('category_id');
            $subcat = $request->input('subcategory_id');
            
            $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)
            ->where('category_id',$input['category_id'])
            ->whereRaw('FIND_IN_SET(?,REPLACE(subcategory_id,",",","))')
            ->with('workoutSchedule')
            ->setBindings([1, $cat, $subcat])
            ->get();
            
        } else {
            $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)->where('category_id',$input['category_id'])->with('workoutSchedule')->get();
         }  
        return response()->json(['status_code' => $this->successStatus , 'message' => '', 'data' => $success]);
    }
    
    public function workoutsByRoutine(Request $request)
    {
        $input = $request->input();
        $routine = $request->input('routine_id');
        $success['ageGroups'] = AgeGroup::get();
        
        if (!empty($request->input('age_group_id'))&& ($request->input('age_group_id') != "null")){
            $age = $request->input('age_group_id');
            
            $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)
            ->whereRaw('FIND_IN_SET(?,REPLACE(routine_id,",",","))')
            ->whereRaw('FIND_IN_SET(?,REPLACE(age_group_id,",",","))')
            ->with('workoutSchedule')
            ->setBindings([1,$routine, $age])
            ->get();
        } else {
            $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)
            ->whereRaw('FIND_IN_SET(?,REPLACE(routine_id,",",","))')
            ->setBindings([1,$routine])
            ->with('workoutSchedule')
            ->get();
         }  
        return response()->json(['status_code' => $this->successStatus , 'message' => '', 'data' => $success]);
    }

    public function workoutsByAgegroup(Request $request)
    {
        $input = $request->input();
        $agegroupId = $request->input('age_group_id');
            
        $success['workoutPlans'] = WorkoutPlan::where('is_activated', 1)
            ->whereRaw('FIND_IN_SET(?,REPLACE(age_group_id,",",","))')
            ->with('workoutSchedule')
            ->setBindings([1, $agegroupId])
            ->get();
    
        return response()->json(['status_code' => $this->successStatus , 'message' => '', 'data' => $success]);
    }
}

resources/views/workoutPlans/create.blade.php
@extends('layouts.web')

@section('top-css')
<style type="text/css">
.page-breadcrumb .d-flex {
    justify-content: space-between;
}
</style>
@endsection

@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Add Workout Plan</h4>
                <a href="{{ route('workoutPlans.index') }}" class="btn btn-primary float-right"><i class="fa fa-arrow-left"></i> Back</a>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <form class="form-horizontal" action="{{ route('workoutPlans.store') }}" enctype="multipart/form-data" method="post">
            @csrf
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <h4 class="card-title">Add Workout Plan</h4>
                            <div class="form-group row">
                                <label for="name" class="col-sm-3 text-right control-label col-form-label">Image/Video</label>
                                <div class="col-sm-9">
                                    <input type='file' name="media" value="{{ old('media') }}"/>
                                    <br>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('media')?$errors->first('media'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="category_id" class="col-sm-3 text-right control-label col-form-label">Category:</label>
                                <div class="col-sm-9">
                                    <select name="category_id" id="category_id" class="demoInputBox select2 form-control " onChange="getSubcategory(this.value);">
                                        <option value disabled selected>Select Category</option>
                                        @foreach ($categories as $key => $category) {
                                            <option value="{{$key}}">{{$category}}</option>
                                        @endforeach
                                    </select>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('category_id')?$errors->first('category_id'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="subcategory_id" class="col-sm-3 text-right control-label col-form-label">Sub Category:</label>
                                <div class="col-sm-9">
                                    <select name="subcategory_id[]" id="subcategory-list" multiple='multiple' class="demoInputBox select2 form-control" >
                                        
                                    </select>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('subcategory_id')?$errors->first('subcategory_id'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="name" class="col-sm-3 text-right control-label col-form-label">Title </label>
                                <div class="col-sm-9">
                                    <input type="text" class="form-control" name="name" value="{{ old('name') }}" id="name" placeholder="Title">
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('name')?$errors->first('name'):'' }}</strong>
                                    </span>
                                </div>   
                            </div>
                            <div class="form-group row">
                                <label for="short_description" class="col-sm-3 text-right control-label col-form-label">Full Description</label>
                                <div class="col-sm-9">
                                    <textarea class="form-control" name="short_description" id="short_description" placeholder="Full Description" rows="5">{{ old('short_description') }}</textarea>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('short_description')?$errors->first('short_description'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="age_group_id" class="col-sm-3 text-right control-label col-form-label">Age Group</label>
                                <div class="col-sm-9">
                                    <select class="select2 form-control" style="width: 100%; height:36px;" name="age_group_id[]" multiple='multiple'>
                                        @foreach($ageGroups as $key => $ageGroup)
                                        <option value="{{$key}}" {{ old('age_group_id') == $key ? 'selected' : '' }}>{{$ageGroup}}</option>
                                        @endforeach
                                    </select>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('age_group_id')?$errors->first('age_group_id'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="routine_id" class="col-sm-3 text-right control-label col-form-label">Routine</label>
                                <div class="col-sm-9">
                                    <select class="select2 form-control" name="routine_id[]" multiple='multiple'>
                                        @foreach($routines as $key => $routine)
                                        <option value="{{$key}}" {{ old('routine_id') == $key ? 'selected' : '' }}>{{$routine}}</option>
                                        @endforeach
                                    </select>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('category_id')?$errors->first('category_id'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="duration" class="col-sm-3 text-right control-label col-form-label">Time Duration(hrs) </label>
                                <div class="col-sm-9">
                                    <input type="text" class="form-control" name="duration" value="{{ old('duration') }}" id="duration" placeholder="Time Duration">
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('duration')?$errors->first('duration'):'' }}</strong>
                                    </span>
                                </div>   
                            </div>
                            <div class="form-group row">
                                <label for="calories_burn" class="col-sm-3 text-right control-label col-form-label">Calories burn</label>
                                <div class="col-sm-9 row">
                                    <input type="text" class="form-control col-sm-6" name="calories" value="{{ old('calories') }}" placeholder="Calories Burn">
                                    <select class="form-control col-sm-6" style="width: 100%; height:36px;" name="calories_burn">
                                        <option value="cal" {{ old('calories_burn') == 'cal' ? 'selected' : '' }}>cal</option>
                                        <option value="kcal" {{ old('calories_burn') == 'kcal' ? 'selected' : '' }}>kcal</option>
                                        <option value="kj" {{ old('calories_burn') == 'kj' ? 'selected' : '' }}>kj</option>
                                    </select>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('calories')?$errors->first('calories'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="border-top">
                    <div class="card-body">
                        <button class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

@section('footer-script')
<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.1.0-beta.1/css/select2.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.1.0-beta.1/js/select2.min.js"></script>
<script type="text/javascript">
    function getSubcategory(val) {
    	$.ajax({
    		type: "GET",
    		url: "{{ route('getSubcategory') }}",
    		data:'category_id='+val,
    		beforeSend: function() {
    			$("#subcategory-list").addClass("loader");
    		},
    		success: function(data){
    		    $("#subcategory-list").html('');
    		    $(data).each(function (i) { //populate child options 
            		$("#subcategory-list").append("<option value=\""+data[i].id+"\">"+data[i].name+"</option>");
            	});
    			$("#subcategory-list").removeClass("loader");
    		}
    	});
    }
    $('.select2').select2({
       placeholder: {
        id: '-1',
        text: '-- Select --'
      }
    });
</script>
@endsection

resources/views/workoutPlans/index.blade.php
@extends('layouts.web')
@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Video Management</h4>
            </div>
        </div>
    </div>
    <div class="container-fluid">
    	@include('flash::message')
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                        <h5 class="card-title">WorkOut Plans
	                        <div class="text-right">
	                            <a href="{{ route('workoutPlans.create') }}" type="button" class="btn btn-success">Add</a>
	                        </div>
	                    </h5>
                        <div class="table-responsive">
                            <table id="zero_config" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Title</th>
                                        <th>Category</th>
                                        <th>Status</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($workoutPlans as $key => $workoutPlan)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>                                 
                                        <td>{{ $workoutPlan->name }}</td>  
                                        <td>{{ $workoutPlan->category->name }}</td>  
                                        <td>
                                        	<a href="{{ url('admin/workoutPlans/deactivate/'.$workoutPlan->id) }}">
							                    @if($workoutPlan->is_activated)
							                    	<button type="button" class="btn-sm btn-success" title="De-Activate"><i class="fa fa-ban"></i> De-Activate</button>
							                	@else
							                		<button type="button" class="btn-sm btn-danger" title="Activate"><i class="fa fa-unlock"></i> Activate</button>
							            		@endif
	                                        </a>
		                                </td>                                     
                                        <td class="">
                                            <div class="comment-footer">
                                                <a href="{{ route('workoutPlans.edit', $workoutPlan->id) }}" type="button" class="btn btn-cyan btn-sm">Edit</a>
                                                <a href="{{ route('workoutPlans.show', $workoutPlan->id) }}" type="button" class="btn btn-info btn-sm">View</a>
                                                <form action="{{ route('workoutPlans.destroy', $workoutPlan->id) }}" method="POST" onsubmit="deleteWorkoutPlan('{{ $workoutPlan->id }}', '{{ $workoutPlan->name }}', event,this)">
                                                @csrf
                                                    <button class="btn-sm btn-danger" title="">DELETE</button>
                                                </form>
                                            </div>
                                        </td>
                                    </tr>
                                    @endforeach
                                </tbody>
                                <tfoot>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Name</th>
                                        <th>Action</th>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('footer-script')
<script type="text/javascript">
    $(document).ready( function () {
        $('#zero_config').DataTable({
            "columnDefs": [{ 'orderable': false, 'targets': 4 }],
        });
    });

    function deleteWorkoutPlan(id, title, event,form)
    {
        event.preventDefault();
        swal({
            title: "Are you sure?",
            text: "You want to delete "+title+" plan",
            icon: "warning",
            buttons: {
                cancel: true,
                confirm: true,
            },
            closeModal: false,
            closeModal: false,
            closeOnEsc: false,
        })
       .then((willDelete) => {
            if (willDelete) {
                $.ajax({
                url: $(form).attr('action'),
                data: $(form).serialize(),
                type: 'DELETE',
                success: function(data) {
                    data = JSON.parse(data);
                    if(data['status']) {
                        swal({
                            title: data['message'],
                            text: "Press OK to continue",
                            icon: "success",
                            buttons: {
                                cancel: true,
                                confirm: true,
                            },
                            closeOnConfirm: false,
                            closeOnEsc: false,
                        })
                        .then((willDelete) => {
                            if (willDelete) {
                                window.location.reload();
                            }
                            });
                        } else {
                             swal("Error", data['message'], "error");
                        }
                    }
                });
            } else {
                swal("Cancelled", title+" plan will not be deleted.", "error");
            }
        });
    }
</script>
@endsection